//--startup - run only once
(
s.waitForBoot{
	SynthDef(\samplerMono, {|out= 0, pan= 0, buf, atk= 0.01, rel= 0.1, gate= 1, amp= 0.5, rate= 1, offset= 0|
		var env= EnvGen.ar(Env.asr(atk, 1, rel), gate, doneAction:2);
		var src= PlayBuf.ar(1, buf, rate, 1, offset*BufFrames.ir(buf), 1);
		OffsetOut.ar(out, Pan2.ar(src, pan, amp*env));
	}).add;
	SynthDef(\samplerStereo, {|out= 0, pan= 0, buf, atk= 0.01, rel= 0.1, gate= 1, amp= 0.5, rate= 1, offset= 0|
		var env= EnvGen.ar(Env.asr(atk, 1, rel), gate, doneAction:2);
		var src= PlayBuf.ar(2, buf, rate, 1, offset*BufFrames.ir(buf), 1)*env;
		OffsetOut.ar(out, Balance2.ar(src[0], src[1], pan, amp*env));
	}).add;
};
s.meter;
)

//record 4 STEREO soundfiles in Audacity or similar program

//--init - run when loading new soundfiles
(
~buffers.do{|x| x.free};
~buffers= [
thisProcess.nowExecutingPath.dirname+/+"aah.wav", //edit to match snd 1
thisProcess.nowExecutingPath.dirname+/+"click.wav", //edit to match snd 2
thisProcess.nowExecutingPath.dirname+/+"psch.wav", //edit to match snd 3
thisProcess.nowExecutingPath.dirname+/+"scrap.wav" //edit to match snd 4
].collect{|x| Buffer.read(s, x)};
TempoClock.default.tempo= 1;
)


//test
~buffers[0].play
~buffers[1].play
~buffers[2].play
~buffers[3].play






(
Pdef(\click, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[0],
	\dur, 0.25,
	\legato, 0.1,
	\amp, Pseg(Pseq([0, 1, 0]), 60)
)).play;
Pdef(\hihat, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[2],
	\dur, 0.125,
	\legato, 0.25,
	\amp, 1
)).play;
Pdef(\kick, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[3],
	\dur, 0.5,
	\legato, 0.1,
	\amp, 0.6
)).play;
)


//intro
(
Pdef(\click, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[0],
	\dur, 0.25,
	\legato, 0.1,
	\amp, Pseg(Pseq([0, 1, 0]), 60)
)).play;
Pdef(\hihat, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[2],
	\dur, 0.25,
	\legato, 0.25,
	\rate, Pseg(Pseq([1, 2]), 60),
	\amp, 1
)).play;
)

//section 2
(
~speed= 6;
Pdef(\hihat, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[2],
	\dur, Pseq([0.25, 0.125], inf),
	\legato, 0.25,
	\rate, Pseg(Pseq([1, 2]), ~speed),
	\amp, 1
)).play;
)

//section 3
(
Pdef(\hihat, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[2],
	\dur, 0.25,
	\legato, 0.25,
	\rate, Pwhite(0.9, 1.1, inf),
	\amp, 1
)).play;
Pdef(\kick, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[3],
	\dur, 0.25,
	\rate, 0.2,
	\legato, 0.2,
	\amp, Pseq([1, 0.3], inf)
)).play;
)



(
Pdef(\hihat, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[2],
	\dur, 0.25,
	\legato, 0.25,
	\rate, Pseg(Pseq([1, 2]), 60),
	\amp, 1
)).play;
Pdef(\kick, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[3],
	\dur, 0.5,
	\legato, 0.1,
	\amp, 0.6
)).play;
)

















//legato, pseg




(
Pdef(\bass, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[1],
	\rate, 0.25,
	\offset, 0.2,
	\atk, 0,
	\dur, 0.5,
	\legato, Pseg([0.01, 0.5], 50),
	\amp, 1
)).play;

Pdef(\snare, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[1],
	\rate, Pseq([2, -2, 3], inf),
	\offset, 0.25,
	\atk, 0,
	\dur, 0.25,
	\legato, 0.1,
	\amp, Pseq([0, 1], inf)
)).play;
Pdef(\hat, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[1],
	\rate, 4,
	\offset, 0.125,
	\atk, 0,
	\dur, 0.25,
	\legato, 0.01,
	\amp, Pseq([0.25, 1, 0.5], inf)
)).play;
)
















~buffers[0].play
~buffers[1].play
~buffers[2].play



//--
(
Pdef(\a, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[0],
	\rate, Pseq([1.0, 1.1, 1.2, 1.3, 1.4, 1.5, 2, 2, 2, 3], inf),
	\dur, Pseq([0.25, 0.25, 0.5], inf),
	\amp, Pseq([0.7, 0.3, 0.1, 0], inf)
)).play(quant:0);

Pdef(\b, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[2],
	\rate, 1,
	\dur, 1,
	\amp, 0.6
)).play;
)


TempoClock.default.tempo= 2

//more parameters to play with...
\legato, Pseq([0.2, 1.1], inf),
\pan, Pseq([-1, 1], inf),
\offset, Pseq([0.0, 0.1, 0.2, 0.3], inf),
\atk, Pseq([0.0, 0.6], inf),
\rel, Pseq([0.5, 1.0, 1.25], inf),



(
Pdef(\a, Pbind(
	\instrument, \samplerStereo,
	\buf, Pseq([~buffers[0], ~buffers[1], ~buffers[2]], inf),
	\rate, Pseq([1.0, 1.1, 1.2, 1.3, 1.4, 1.5, 2, 2, 2, 3], inf),
	\dur, Pseq([0.25, 0.25, 0.5], inf),
	\amp, Pseq([0.7, 0.3, 0.1, 0], inf)
)).play(quant:0);

Pdef(\b, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[2],
	\rate, 1.01,
	\dur, 1.01,
	\amp, Pseq([0.7, 0.3, 0.1, 0], inf)
)).play;
)






//trace is good for debugging
(
Pdef(\a, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[1],
	\offset, Pseg([0, 1], 30).trace,
	\legato, 0.1,
	\dur, 0.5
)).play;
)


//small diff in dur
(
Pdef(\a, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[0],
	\dur, 0.5,
	\amp, 0.5,
	\pan, -0.9
)).play;
Pdef(\b, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[0],
	\dur, 0.505,
	\amp, 0.5,
	\pan, 0.9
)).play;
)

(
Pdef(\a, Pbind(
	\instrument, \samplerStereo,
	\buf, Pseq([~buffers[0], ~buffers[0], ~buffers[1]], inf),
	\amp, 0.5,
	\legato, 0.2,
	\dur, Pseq([0.5, 0.5, 0.5, 1], inf)
)).play;
Pdef(\b, Pbind(
	\instrument, \samplerStereo,
	\buf, Pseq([~buffers[2], ~buffers[2], ~buffers[1], ~buffers[2]], inf),
	\dur, Pseq([0.25, 0.25, 2], inf),
	\amp, 0.1,
	\legato, 0.2
)).play;
)

(
Pdef(\a, Pbind(
	\instrument, \samplerStereo,
	\buf, Pseq([~buffers[0], ~buffers[0], ~buffers[1]], inf),
	\amp, 0.5,
	\legato, Pseq([0.1, 0.2, 0.3, 0.4], inf),
	\dur, Pseq([0.5, 0.5, 0.5, 1], inf)
)).play;
Pdef(\b, Pbind(
	\instrument, \samplerStereo,
	\buf, Pseq([~buffers[2], ~buffers[2], ~buffers[1], ~buffers[2]], inf),
	\dur, Pseq([0.25, 0.25, 2], inf),
	\amp, 0.1,
	\legato, 0.2
)).play;
Pdef(\c, Pbind(
	\instrument, \samplerStereo,
	\buf, Pseq([~buffers[1], ~buffers[2]], inf),
	\rate, Pseq([-0.5, -0.5, -0.5], inf),
	\dur, Pseq([0.25, 0.75, 0.25, 0.25, 0.25, 0.25, 0.25], inf),
	\amp, 0.3,
	\pan, 0,
	\legato, 1
)).play;
)

(
Pdef(\a).stop;
Pdef(\b).stop;
Pdef(\c).stop;
)

(
Pdef(\hat).stop;
Pdef(\snare).stop;
Pdef(\kick).stop;
Pdef(\hihat).stop;
Pdef(\bass).stop;
)
