//--startup - run only once
(
s.waitForBoot{
	SynthDef(\samplerMono, {|out= 0, pan= 0, buf, atk= 0.01, rel= 0.1, gate= 1, amp= 0.5, rate= 1, offset= 0|
		var env= EnvGen.ar(Env.asr(atk, 1, rel), gate, doneAction:2);
		var src= PlayBuf.ar(1, buf, rate, 1, offset*BufFrames.ir(buf), 1);
		OffsetOut.ar(out, Pan2.ar(src, pan, amp*env));
	}).add;
	SynthDef(\samplerStereo, {|out= 0, pan= 0, buf, atk= 0.01, rel= 0.1, gate= 1, amp= 0.5, rate= 1, offset= 0|
		var env= EnvGen.ar(Env.asr(atk, 1, rel), gate, doneAction:2);
		var src= PlayBuf.ar(2, buf, rate, 1, offset*BufFrames.ir(buf), 1)*env;
		OffsetOut.ar(out, Balance2.ar(src[0], src[1], pan, amp*env));
	}).add;
	s.meter;
	//some network inputs (port 57120 by default)
	OSCFunc({|msg| ~red= msg[1]}, \red).permanent= true;
	OSCFunc({|msg| ~green= msg[1]}, \green).permanent= true;
	OSCFunc({|msg| ~blue= msg[1]}, \blue).permanent= true;
	OSCFunc({|msg| ~analog.value(msg[1])}, \analog).permanent= true;
	OSCFunc({|msg| ~digital.value(msg[1])}, \digital).permanent= true;
};
)

//use with camera_colourtracking.pd
//and two of your own pop songs

//--init - run when loading new soundfiles
(
~buffers.do{|x| x.free};
~buffers= [
	//here replace with your own stereo soundfiles - add as many as you like.
	thisProcess.nowExecutingPath.dirname+/+"2blow.wav",
	thisProcess.nowExecutingPath.dirname+/+"2cup.wav",
	thisProcess.nowExecutingPath.dirname+/+"2hrm.wav",
	"/Applications/SuperCollider344/sounds/pop2.aiff", //edit path to popsong 1
	"/Applications/SuperCollider344/sounds/pop3.aiff" //edit path to popsong 2
].collect{|x| Buffer.read(s, x)};
)


OSCFunc.trace(true)
OSCFunc.trace(false)
(
~red= 0.5;
Pdef(\red, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[2],
	\dur, 1.1-Pfunc({~red}),
	\rate, 1,
	\lag, 1,
	\amp, Pfunc({~red})
)).play;
)

OSCresponder(nil, \red, {|r, t, m| ~red= m[1]}).add;









(
Pdef(\one, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[1],
	\dur, ~buffers[1].duration*6,
	\pan, Pgauss(0, 0.5, inf),
	\rate, Pgauss(1, 0.05, inf)*Prand([1, 1, 1, 1, -1], inf)+Prand([0, 0, 0, 0, 1], inf),
	\atk, 4,
	\rel, 6,
	\amp, 0.5,
	\offset, Pgauss(0.5, 0.1, inf),
	\legato, 5
)).play;
)


s.makeWindow


//pop mashup
(
Pdef(\one, Pbind(
	\instrument, \samplerStereo,
	\buf, Prand([~buffers[3], ~buffers[4]], inf),
	\dur, Pbrown(0.125, 1, 0.125, inf),
	\pan, Pwhite(-1, 1, inf),
	\rate, Pwhite(-2, 2, inf).round(0.5),
	\atk, 0.005,
	\rel, 0.1,
	\amp, Pwhite(0.3, 0.7, inf),
	\offset, Pwhite(0, 1, inf).round(0.05),
	\legato, 4
)).play;
)


Pgauss - randomness around a central value
Prand - random choise from a list
Pwhite - 'pure' random from min to max
Pbrown - drunk walk type of randomness











//--simple colour tracking with webcamera to control the music
(
Pdef(\a, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[1],
	\rate, Pfunc({~red.linlin(0, 1, 1, 5)}),
	\dur, Pfunc({~red.linlin(0, 1, 1, 0.5)}),
	\amp, 0.5,
)).play;
)


(
Pdef(\b, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[0],
	\offset, Pfunc({~green}),
	\rate, Pfunc({~green*2}),
	\legato, 1,
	\dur, 0.5,
	\amp, Pfunc({~blue})
)).play;
)

(
Pdef(\a).stop;
Pdef(\b).stop;
)


//--ambient music (overlaps with legato > 1)
(
Pdef(\a, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[0],
	\dur, ~buffers[0].duration*2,
	\legato, 5,
	\rate, Pgauss(1, 0.01)*Prand([1, 0.5], inf),
	\lag, Pgauss(0.1, 0.01),
	\offset, Pgauss(0.1, 0.01),
	\pan, Pgauss(0, 0.5),
	\amp, Pgauss(0.5, 0.2),
)).play;
Pdef(\b, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[1],
	\dur, ~buffers[1].duration*2,
	\legato, 4,
	\rate, Pgauss(1, 0.01)*Prand([1, 0.125], inf),
	\lag, Pgauss(0.1, 0.01),
	\offset, Pgauss(0.1, 0.01),
	\pan, Pgauss(0, 0.5),
	\amp, Pgauss(0.5, 0.2),
)).play;
)

(
Pdef(\a, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[0],
	\dur, ~buffers[0].duration*30,
	\legato, 2,
	\atk, 8,
	\rel, 12,
	\rate, Pgauss(1, 0.02)*Prand([1, 0.5], inf),
	\lag, Pgauss(0.1, 0.01),
	\offset, Pgauss(0.1, 0.01),
	\pan, Pgauss(0, 0.5),
	\amp, Pgauss(0.5, 0.2),
)).play;
Pdef(\b, Pbind(
	\instrument, \samplerStereo,
	\buf, ~buffers[1],
	\dur, ~buffers[1].duration*20,
	\legato, 2,
	\atk, 4,
	\rel, 5,
	\rate, Pgauss(1, 0.01)*Prand([1, 0.125], inf),
	\lag, Pgauss(0.1, 0.01),
	\offset, Pgauss(0.1, 0.01),
	\pan, Pgauss(0, 0.5),
	\amp, Pgauss(0.5, 0.2),
)).play;
)

//--additional example showing how to trigger changes externally
(
~digital= {|val|
	[
		{
			Pdef(\a, Pbind(
				\instrument, \samplerStereo,
				\buf, ~buffers[0],
				\dur, 0.1,
				\rate, Pfunc({~red*4}),
				\amp, 0.5
			)).play(quant: 0);
		},
		{
			Pdef(\a, Pbind(
				\instrument, \samplerStereo,
				\buf, ~buffers[1],
				\dur, 0.1,
				\rate, Pfunc({~red*4}),
				\amp, 0.5
			)).play(quant: 0);
		}
	].wrapAt(val.asInteger.postln).value;
};
~analog= {|val|
	~red= val.linlin(0, 1023, 0, 1);
};
)

~digital.value(0)
~digital.value(1)
